open Syntax
    
(* Definitional interpreter for λ-calculus with shift and reset : eval1 *)

(* Value : プログラムの実行結果を表す型 *)
type v = VNum of int
       | VFun of (v -> c -> t -> v)
       | VCont of c * t

and c = v -> t -> v

and t = TNil | Trail of c

(* プログラムの実行結果を文字列にする関数 *)
(* Value.to_string : Value.t -> string *)
let rec to_string value = match value with
    VNum (n) -> string_of_int n
  | VFun (_) -> "<VFun>"
  | VCont (_, _) -> "<VCont>"

(* プログラムの実行結果をプリントする関数 *)
(* Value.print : Value.t -> unit *)
let print exp =
  let str = to_string exp in
  print_string str
