open Syntax

(* Delinearized interpreter : eval5 *)

(* Value : プログラムの実行結果を表す型 *)
type v = VNum of int
       | VFun of e * string * string list * v list
       | VCont of c * s * t
       | VEnv of v list

and c = C0
      | CApp0 of e * string list * c
      | CApp1 of c
      | COp0 of e * string list * op_t * c
      | COp1 of op_t * c
      | CAppend of c * c

and s = SNil | SCons of v * s
      | SAppend of s * s

and t = TNil | Trail of c * s

(* プログラムの実行結果を文字列にする関数 *)
(* Value.to_string : Value.t -> string *)
let rec to_string value = match value with
    VNum (n) -> string_of_int n
  | VFun (_) -> "<VFun>"
  | VCont (_, _, _) -> "<VCont>"
  | VEnv (_) -> "<VEnv>"

(* プログラムの実行結果をプリントする関数 *)
(* Value.print : Value.t -> unit *)
let print exp =
  let str = to_string exp in
  print_string str
